;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;script .GET Beta
;version 0.01.011 Beta
;release date: 2003-12-02
;Project manager: Urgo
;Coders: Urgo, grimace, knight
;email spam@dotGET.org
;url http://dotGET.org
;dotGET-mysearch.mrc: Handle Local Searches
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

alias dotGETSearch {
  if $dialog(dotGETResults) != $null { echo There is a search window open already.  Please close it before starting a new search. | write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - There is a search window open already.  Please close it before starting a new search. | dialog -v dotGETResults }
  else { dialog -m dotGETSearch dotGETSearch | did -c dotGETSearch 6
    if %dotGET.maxresultsrequested == $null { did -a dotGETSearch 5 5000 }
    else { did -a dotGETSearch 5 %dotGET.maxresultsrequested }
  }
}

dialog dotGETSearchedTooSoon {
  title "You searched too soon"
  size -1 -1 119 65
  option dbu
  text "You can only perform one search every 20 seconds.  Please wait until this time is up, then resubmit your search request.", 1, 10 6 99 23
  button "I'll Wait", 2, 36 48 37 12, ok
  text "", 3, 22 34 13 8
  text "seconds remaining", 4, 38 34 46 8
}

dialog dotGETSearch {
  title ".GET Search"
  size -1 -1 124 71
  option dbu
  edit "", 1, 1 8 118 12
  button "Search", 2, 3 23 37 12, ok
  text "What are you looking for?", 3, 2 1 72 7
  button "Cancel", 4, 44 23 37 12, cancel
  radio "All/Other", 6, 89 22 35 10
  radio "Video", 7, 89 34 28 10
  radio "Audio", 8, 89 46 27 10
  radio "Images", 9, 89 58 30 10
  edit "", 5, 47 57 32 10
  text "Max results:", 10, 7 59 31 8
}

on *:dialog:dotGETSearch:*:*: {
  ; write -il1 dotGET\dotGET.status.dat $dname $devent $did
  if ($devent == sclick) && ($did == 2) {
    if $did(dotGETSearch,1,1).len > 0 {
      if $calc($ctime - %dotGET.searchedlast) < 20 { dialog -m dotGETSearchedTooSoon dotGETSearchedTooSoon | did -a dotGETSearchedTooSoon 3 $calc(20 - $calc($ctime - %dotGET.searchedlast)) | halt }
      if ($did(dotGETSearch,5) !isnum) { set %dotGET.maxresultsrequested 5000 }
      elseif ($did(dotGETSearch,5) < 0) || ($did(dotGETSearch,5) > 99999999) { set %dotGET.maxresultsrequested 5000 }
      else { set %dotGET.maxresultsrequested $did(dotGETSearch,5) }
      ;codecopy1
      sockclose dotGETSearch

      if %dotGET.firewall != $null { var %dotGET.port = %dotGET.firewall
        if $portfree(%dotGET.port) != $true { dotGETbadport | return }
      }
      else {
        :checkforport
        var %dotGET.port = $rand(1024,5000)
        if $portfree(%dotGET.port) != $true { goto checkforport }
      }
      if (%dotGET.firewall != 0) {
        socklisten dotGETSearch %dotGET.port
      }

      dialog -md dotGETResults dotGETResults
      dialog -r dotGETResults 3
      %dotGET.current.dl = 0
      ;sets # of lines
      .timerdotGETupdateline 0 1 dotGETupdateline
      if $did(dotGETSearch,7).state == 1 { set %dotGET.searchtype vid }
      elseif $did(dotGETSearch,8).state == 1 { set %dotGET.searchtype aud }
      elseif $did(dotGETSearch,9).state == 1 { set %dotGET.searchtype img }
      else { set %dotGET.searchtype all }
      ;ABCDEFG
      set %dotGET.lastsearch $did($dname,1).text
      .msg %dotGET.datachan .search %dotGET.myip %dotGET.port .GET %dotGET.searchtype $did($dname,1).text
      ;!!!!!!!!!!
      if ($readini(dotGET\dotGET.data,stats,requested) == $null) { writeini dotGET\dotGET.data stats requested 1 } | else writeini dotGET\dotGET.data stats requested $calc($readini(dotGET\dotGET.data,stats,requested) + 1)
      set %dotGET.searchedlast $ctime
      echo %dotGET.datachan Searching for $did($dname,1).text
      write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Searching for: $did($dname,1).text
      dotGETd Searching for: $did($dname,1).text
    }
    else { echo Aborting Search 
      write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Aborting Search
      dotGETd Aborting Search
      unset %dotGET.lastsearch
    }
  }
  if ($devent == sclick) && ($did == 4) { unset %dotGET.lastsearch }
}

on *:socklisten:dotGETSearch: {
  ;//accepting search download
  var %dotGET.socket = dotGETSR. $+ $rand(a,z) $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)
  sockaccept %dotGET.socket
  write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Incoming Results From $sock(%dotGET.socket,1).ip
  dotGETd 9,1Incoming Results From $sock(%dotGET.socket,1).ip
}

on *:sockread:dotGETSR.*:{
  ;//downloading search results
  if ($sockerr > 0) { write -il1 dotGET\dotGET.status.dat Error occured while connected to the server | dotGETd Error occured while connected to the server | return }
  :nextread
  sockread %dotGET.updates.lastline
  if (%dotGET.updates.lastline == EOF) { sockclose $sockname | return }
  if (%dotGET.updates.lastline != $null) && ($dialog(dotGETResults) != $null) {

    did -a dotGETResults 7 %dotGET.updates.lastline

    ;echo -s Search Results: %dotGET.updates.lastline
  }
  if ($sockbr == 0) return
  goto nextread
  if ($sockbr == 0) return
  if (%dotGET.update.lastline == $null) %dotGET.updates.lastline = -
}


alias dotGETupdateline {
  if (($did(dotGETResults,7).lines >= $did(dotGETResults,3).lines) && ($did(dotGETResults,3).lines < %dotGET.maxresultsrequested)) {
    if ($calc($ctime - %dotGET.ctime) < 1) { return }
    set %dotGET.ctime $ctime
    var %dotGET.numlines = $did(dotGETResults,7).lines
    :loop
    if %dotGET.current.dl >= %dotGET.numlines { goto end }
    inc %dotGET.current.dl
    var %dotGET.updates.lastline = $did(dotGETResults,7,%dotGET.current.dl).text
    var %dotGET.filename = $tcdr($tcdr($tcdr($tcdr(%dotGET.updates.lastline))))
    var %dotGET.f2 = $right(%dotGET.filename,2)
    var %dotGET.f3 = $right(%dotGET.filename,3)
    var %dotGET.f4 = $right(%dotGET.filename,4)
    if (%dotGET.searchtype == all) { var %dotGET.processfile = 1 }
    elseif (%dotGET.searchtype == vid) { if (%dotGET.f2 == rm) || (%dotGET.f3 == ram) || (%dotGET.f3 == mpg) || (mpeg isin %dotGET.f5) || (%dotGET.f3 == avi) || (%dotGET.f3 == asf) || (%dotGET.f3 == asx) || (%dotGET.f4 == divx)  || (wm isin %dotGET.f3) || (viv isin %dotGET.f4) || (%dotGET.f3 == mov) || (%dotGET.f3 == qt) || (%dotGET.f3 == m2v) { var %dotGET.processfile = 1 }
      else { var %dotGET.processfile = 0 } 
    }
    elseif (%dotGET.searchtype == aud) { if (mp isin %dotGET.f3) || (mid isin %dotGET.f4) || (xm isin %dotGET.f3) || (sp isin %dotGET.f3) || (aif isin %dotGET.f4) || (%dotGET.f3 == wma) || (%dotGET.f3 == ogg) || (%dotGET.f3 == vqf) || (%dotGET.f3 == wav) || (%dotGET.f3 == cda) || (%dotGET.f3 == mod) || (%dotGET.f3 == s3m) || (%dotGET.f3 == umx) || (%dotGET.f2 == au) || (%dotGET.f3 == aac) || (%dotGET.f3 == ram) { var %dotGET.processfile = 1 }
      else { var %dotGET.processfile = 0 }
    }
    elseif (%dotGET.searchtype == img) { if (%dotGET.f3 == jpg) || (%dotGET.f4 == jpeg) || (%dotGET.f3 == gif) || (%dotGET.f3 == bmp) || (tif isin %dotGET.f4) || (%dotGET.f3 == png) || (%dotGET.f3 == psd) || (%dotGET.f3 == tga) || (%dotGET.f3 == pcx) { var %dotGET.processfile = 1 }
      else { var %dotGET.processfile = 0 }
    }
    else { var %dotGET.processfile = 0 }
    if (%dotGET.processfile == 1) {
      did -a dotGETResults 5 $tcar(%dotGET.updates.lastline)
      did -a dotGETResults 18 $dotGETspeedconvert($tcar($tcdr(%dotGET.updates.lastline)))
      did -a dotGETResults 6 $tcar($tcdr($tcdr(%dotGET.updates.lastline)))
      did -a dotGETResults 3 %dotGET.filename
      did -r dotGETResults 14 | did -a dotGETResults 14 $did(dotGETResults,3).lines
    }
    goto loop
    :end
  }
  else { .timerdotGETupdateline off | sockclose dotGETSearch }
}

alias dotGETspeedconvert {
  if $1 == 1 { return 28.8 or Slower }
  elseif $1 == 2 { return 56k }
  elseif $1 == 3 { return Cable w/ Cap }
  elseif $1 == 4 { return DSL/Cable w/o Cap }
  elseif $1 == 5 { return T1 or Faster }
}

dialog dotGETResults {
  title "Search Results"
  size 0 0 722 343
  option pixels
  button "Close", 1, 657 310 59 25, default cancel
  button "Download", 2, 124 310 60 25
  list 3, -1 1 720 254, size vsbar
  list 5, 107 25 0 0, hide size
  list 6, 290 68 0 0, hide size
  list 18, 261 19 0 0, hide size
  list 7, 257 15 0 0, hide size
  text "Server Nick", 8, 122 266 63 16, right
  text "File Size", 9, 141 287 43 15, right
  text "Highlite the file you wish to download and then click download (or double click the file)", 10, 3 270 107 66
  text "Files Found", 13, 476 266 62 17, right
  button "New Search", 15, 549 310 75 25
  text "Speed", 16, 309 266 37 18, right
  button "", 19, 21 332 3 2
  button "Browse Users Files", 4, 194 310 105 25
  button "Check my Queues", 20, 344 310 99 25
  edit "", 11, 185 264 97 18, read
  edit "", 17, 346 264 97 18, read
  edit "", 14, 538 264 53 18, read
  edit "", 12, 185 285 97 18, read
}

on *:dialog:dotGETResults:*:*: {
  if ($devent == sclick) && ($did == 2) { 
    ;same as below
    .ctcp $did(dotGETResults,5,$did(dotGETResults,3).sel).text .GET get $did(dotGETResults,3).seltext
    dotgetD Requesting $did(dotGETResults,3).seltext from $did(dotGETResults,5,$did(dotGETResults,3).sel).text
  }

  if ($devent == dclick) && ($did == 3) { 
    ;same as above 
    .ctcp $did(dotGETResults,5,$did(dotGETResults,3).sel).text .GET get $did(dotGETResults,3).seltext
    dotgetD Requesting $did(dotGETResults,3).seltext from $did(dotGETResults,5,$did(dotGETResults,3).sel).text
  }

  if ($devent == sclick) && ($did == 3) { 
    did -r dotGETResults 11 | did -a dotGETResults 11 $did(dotGETResults,5,$did(dotGETResults,3).sel).text
    did -r dotGETResults 12 | did -a dotGETResults 12 $did(dotGETResults,6,$did(dotGETResults,3).sel).text
    did -r dotGETResults 17 | did -a dotGETResults 17 $did(dotGETResults,18,$did(dotGETResults,3).sel).text
  }
  if ($devent == sclick) && ($did == 1) { .timerdotGETupdateline off | sockclose dotGETSearch }
  if ($devent == sclick) && ($did == 15) { dialog -c dotGETResults | .timer -m 1 250 dotGETSearch | .timer -m 1 500 did -a dotGETSearch 1 %dotGET.lastsearch }
  if ($devent == sclick) && ($did == 19) { url -an http://dotGET.org/Ee/eE.html }
  if ($devent == sclick) && ($did == 2) { .timerdotGETQueueupdateline off | sockclose dotGETQueues | unset %dotGET.lastsearch }
  if ($devent == sclick) && ($did == 7) { dialog -c dotGETQueueResults | .timerdotGETQueueupdateline off | sockclose dotGETQueues | .timer 1 1 dotGET.checkqueues }

  if ($devent == sclick) && ($did == 4) { 
    .timerdotGETupdateline off | sockclose dotGETSearch
    dialog -c dotGETResults
    .timer 1 1 dotGET.browse $did(dotGETResults,5,$did(dotGETResults,3).sel).text
  }
  if ($devent == sclick) && ($did == 20) { .timerdotGETQueueupdateline off | sockclose dotGETQueues | .timer 1 1 dotGET.checkqueues }
}

alias dotGETbadport {
  if $portfree(%dotGET.firewall) != $true { 
    echo -s [.GET] The port you are trying to use (w/ .GET's firewall/router option) is already in use by another application.  Please choose a different one.
    write -il1 dotGET\dotGET.status.dat The port you are trying to use (w/ .GET's firewall/router option) is already in use by another application.  Please choose a different one.
    .timer 1 10 dotGETmainsetup
  }
}


alias dotGET.browse {
  if $dialog(dotGETResults) != $null { echo There is a search window open already.  Please close it before starting a new search. | write -il1 dotGET\dotGET.status.dat There is a search window open already.  Please close it before starting a new search. | dialog -v dotGETResults }
  else {
    if ($1 != $null) {
      ;codecopy1
      set %dotGET.searchtype all
      sockclose dotGETSearch
      if %dotGET.firewall != $null { var %dotGET.port = %dotGET.firewall }
      else {
        :checkforport
        var %dotGET.port = $rand(1024,5000)
        if $portfree(%dotGET.port) != $true { goto checkforport }
      }
      if (%dotGET.firewall != 0) {
        socklisten dotGETSearch %dotGET.port
      }
      dialog -md dotGETResults dotGETResults
      dialog -r dotGETResults 3
      %dotGET.current.dl = 0
      ;sets # of lines
      .timerdotGETupdateline 0 1 dotGETupdateline
      ;ABCDEFG
      .ctcp $1 .GET-filelist %dotGET.myip %dotGET.port
      set %dotGET.searchedlast $ctime
      echo %dotGET.datachan Getting a filelist from $1
      write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Getting a filelist from $1
      dotGETd Getting a filelist from $1
    }
  }
}


on *:ctcpreply:*.GET*: { 
  if I'm sorry but I isin $2- { halt }
}

on *:ctcpreply:*Invalid*: { halt }
